#define num_datasets 720

String colors[num_sensors_max] = {"red","green","magenta","orange","lime","yellow"};

struct wp
{
  uint8_t temp[num_sensors_max];
  int8_t hour;
};

wp wp_arr[num_datasets];
uint16_t datasetpt = 0;

void clearwp()
{
  for(int i=0;i<num_datasets;i++) wp_arr[i].hour = -1;
}

void storewp(float inp[], int8_t hour)
{
  wp_arr[datasetpt].hour = hour;
  for (int i=0;i<num_sensors;i++) 
    wp_arr[datasetpt].temp[i] = (uint8_t)constrain(2.0*inp[i],0,254);
  datasetpt++;
  if (datasetpt >= num_datasets) datasetpt = 0;
}

void handleNotFound() 
{
  server.send(404, "text/plain", "Not Here");
}

int strsize;

void handleCmd() 
{
  String out;
  char temp[40];

  for (uint8_t i = 0; i < server.args(); i++)
  {
    if      (server.argName(i) == "on")  IsActive = true;  
    else if (server.argName(i) == "of")  IsActive = false; 
    else if (server.argName(i) == "fon") IsFloor  = true; 
    else if (server.argName(i) == "fof") IsFloor  = false; 
    else if (server.argName(i) == "u60l50") { HIlimit =  60; LOlimit = 50; }
    else if (server.argName(i) == "u55l45") { HIlimit =  55; LOlimit = 45; } 
    else if (server.argName(i) == "u50l40") { HIlimit =  50; LOlimit = 40; } 
    else if (server.argName(i) == "u45l35") { HIlimit =  45; LOlimit = 35; } 
  }
  
  out += "<html><br><br><center>\n";
    
  if (IsActive) 
    out += "<button onclick=\"window.location.href='/cmd?of\';\">Burner is ON </button>\n";
  else               
    out += "<button onclick=\"window.location.href='/cmd?on\';\">Burner is OFF</button>\n";
  out += "&emsp;\n";
  
  if (IsFloor)
    out += "<button onclick=\"window.location.href='/cmd?fof\';\">Floor is ON </button>\n";
  else               
    out += "<button onclick=\"window.location.href='/cmd?fon\';\">Floor is OFF</button>\n";
  out += "<br><br>\n";  
    
  sprintf(temp,"Hi limit %d&emsp;\n",HIlimit);
  out += temp;  
  sprintf(temp,"Lo limit %d<br><br>\n",LOlimit);
  out += temp;
  
  out += "Preset:&emsp;\n";
  out += "<button onclick=\"window.location.href='/cmd?u60l50\';\">Hi 60 &emsp; Lo 50</button>\n";
  out += "&emsp;\n";
  out += "<button onclick=\"window.location.href='/cmd?u55l45\';\">Hi 55 &emsp; Lo 45</button>\n";
  out += "&emsp;\n";
  out += "<button onclick=\"window.location.href='/cmd?u50l40\';\">Hi 50 &emsp; Lo 40</button>\n";
  out += "&emsp;\n";
  out += "<button onclick=\"window.location.href='/cmd?u45l35\';\">Hi 45 &emsp; Lo 35</button>\n";

  out += "<br><br>";
  sprintf(temp,"Kessel: %d&emsp;\n",(int)celsius3[kessel]);
  out += temp;
  sprintf(temp,"Vorlauf: %d&emsp;\n",(int)celsius3[vorlauf]);
  out += temp;
  sprintf(temp,"R&uuml;cklauf: %d&emsp;\n",(int)celsius3[rücklauf]);
  out += temp;

  out += "<br><br>";
  if (Burner) out += "Burner ON&emsp;\n";
  else        out += "Burner OFF&emsp;\n";
  if (Pumpe1) out += "Pumpe1 ON&emsp;\n";
  else        out += "Pumpe1 OFF&emsp;\n";
  if (Pumpe2) out += "Pumpe2 ON&emsp;\n";
  else        out += "Pumpe2 OFF&emsp;\n";

  /*
  out += "<br><br>";
  sprintf(temp,"strsize %d<br>\n",strsize);
  out += temp;
  */
  
  out += "</center></html>";
  server.send(200, "text/html", out);  
}

int8_t oldstate = 0;

void drawGraph() 
{
  String out;
  out.reserve(3800);
  uint8_t oldwp = 0; int oldi = 0;
  int8_t oldhour = -1;

// 210 - temp*2

  out += "<svg viewBox=\"0 0 740 240\" xmlns=\"http://www.w3.org/2000/svg\">\n";
  out += "<rect x=\"10\" y=\"0\" width=\"720\" height=\"240\" stroke=\"black\" fill=\"none\"/>\n";
  out += "<line x1=\"10\" y1=\"120\" x2=\"730\" y2=\"120\" stroke=\"silver\"/>\n";
  out += "<line x1=\"10\" y1=\"160\" x2=\"730\" y2=\"160\" stroke=\"silver\"/>\n";
  out += "<line x1=\"10\" y1=\"200\" x2=\"730\" y2=\"200\" stroke=\"silver\"/>\n";
//out += "<text x=\"15\" y=\"10\" stroke=\"grey\" font-size=\"50%\">0..80deg, 12 h</text>\n";
  
#if defined has_ntp
  for (int i=0;i<num_datasets;i++)
  {
    int8_t newstate, newhour;
    uint16_t pos = datasetpt + i;
    if (pos >= num_datasets) pos -= num_datasets;
    newhour = wp_arr[pos].hour;
    if ((newhour != oldhour) && (oldhour >= 0))
    {
      char temp[100];
      if ((newhour == 12) || (newhour == 0))  // 12, 24
      {
        sprintf(temp,"<line x1=\"%d\" y1=\"240\" x2=\"%d\" y2=\"210\" stroke=\"black\" />\n",10+i,10+i);
        out += temp;        
      }
      else if ((newhour == 6) || (newhour == 18)) // 6, 18
      {
        sprintf(temp,"<line x1=\"%d\" y1=\"240\" x2=\"%d\" y2=\"220\" stroke=\"black\" />\n",10+i,10+i);
        out += temp;        
      }
      else 
      {
        sprintf(temp,"<line x1=\"%d\" y1=\"240\" x2=\"%d\" y2=\"230\" stroke=\"black\" />\n",10+i,10+i);
        out += temp;        
      }
    }
    oldhour = newhour;
  }
#endif
    
  for (int k=0;k<num_sensors;k++)
  {
    out += "<polyline points=\"";
    char temp[100];
    // datasetpt is now, show the past
    for (int i=0;i<num_datasets;i++)
    {
      uint16_t pos = datasetpt + i;
      if (pos >= num_datasets) pos -= num_datasets;
      if (wp_arr[pos].hour >= 0)
      {
        int tempdata = wp_arr[pos].temp[k];
        sprintf(temp,"%d,%d ",10+i,240-tempdata);
        out += temp;
      }
    }
    out += "\" fill=\"none\" stroke=\""; out += colors[k]; out += "\" />\n"; 
  }
  
  //strsize = out.length();  
  out += "</svg>\n";
  
  server.send(200, "image/svg+xml", out);
}
